Subject: Re: ethtool discrepancy between observed behaviour and comments

From: Kev Jackson <[email-masked]>
Date: Wed, 16 Jun 2021 10:50:38 +0100

Hi,

On Tue, Jun 15, 2021 at 12:40:50PM -0700, Jakub Kicinski wrote:
> I'm not sure I grasped what the problem is. Could you perhaps share
> what you're trying to do that works with netlink vs IOCTL? Best if
> it's in form of:
> 
> $ ethtool -l $ifc
> $ ./ethtool-ioctl -L $ifc ...
> # presumably fails IIUC?
> $ ./ethtool-nl -L $ifc ...
> # and this one succeeds?
> 
> where ethtool-ioctl and ethtool-nl would be hacked up ethtool binaries
> which only use one mechanism instead of trying to autoselect.

I have rechecked my assumptions that the EINVAL was propogating from the check
on the rx_count/tx_count and discovered that it wasn't.  After I realised this,
I found that the interface I was trying to call ETHTOOL_SCHANNEL with doesn't
support that operation - there are 2 NICs in this test machine.

Apologies for the noise on the mailing list/your inboxes, I now have a fully
working ETHTOOL_GCHANNEL/ETHTOOL_SCHANNEL test harness (so long as I point my
code at the correct interface!)

Thanks,
Kev